diff -aruN --binary 15/libraries/joomla/html/parameter/element/usergroup.php 16/libraries/joomla/html/parameter/element/usergroup.php
--- 15/libraries/joomla/html/parameter/element/usergroup.php	2009-05-29 13:54:26.000000000 +0200
+++ 16/libraries/joomla/html/parameter/element/usergroup.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
-* @version		$Id: usergroup.php 10381 2008-06-01 03:35:53Z pasamio $
+* @version		$Id: usergroup.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla.Framework
 * @subpackage	Parameter
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/html/parameter/element.php 16/libraries/joomla/html/parameter/element.php
--- 15/libraries/joomla/html/parameter/element.php	2009-05-29 13:54:28.000000000 +0200
+++ 16/libraries/joomla/html/parameter/element.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
-* @version		$Id: element.php 10707 2008-08-21 09:52:47Z eddieajau $
+* @version		$Id: element.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla.Framework
 * @subpackage	Parameter
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/html/parameter.php 16/libraries/joomla/html/parameter.php
--- 15/libraries/joomla/html/parameter.php	2009-05-29 13:54:28.000000000 +0200
+++ 16/libraries/joomla/html/parameter.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
- * @version		$Id: parameter.php 10707 2008-08-21 09:52:47Z eddieajau $
+ * @version		$Id: parameter.php 14401 2010-01-26 14:10:00Z louis $
  * @package		Joomla.Framework
  * @subpackage	Parameter
- * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+ * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
  * @license		GNU/GPL, see LICENSE.php
  * Joomla! is free software. This version may have been modified pursuant
  * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/html/toolbar/button/confirm.php 16/libraries/joomla/html/toolbar/button/confirm.php
--- 15/libraries/joomla/html/toolbar/button/confirm.php	2009-05-29 13:54:28.000000000 +0200
+++ 16/libraries/joomla/html/toolbar/button/confirm.php	2010-04-23 13:40:18.000000000 +0200
@@ -3,7 +3,7 @@
 * @version		$Id:confirm.php 6961 2007-03-15 16:06:53Z tcp $
 * @package		Joomla.Framework
 * @subpackage	HTML
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/html/toolbar/button/custom.php 16/libraries/joomla/html/toolbar/button/custom.php
--- 15/libraries/joomla/html/toolbar/button/custom.php	2009-05-29 13:54:28.000000000 +0200
+++ 16/libraries/joomla/html/toolbar/button/custom.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
-* @version		$Id: custom.php 10707 2008-08-21 09:52:47Z eddieajau $
+* @version		$Id: custom.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla.Framework
 * @subpackage	HTML
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/html/toolbar/button/help.php 16/libraries/joomla/html/toolbar/button/help.php
--- 15/libraries/joomla/html/toolbar/button/help.php	2009-05-29 13:54:28.000000000 +0200
+++ 16/libraries/joomla/html/toolbar/button/help.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
-* @version		$Id: help.php 10707 2008-08-21 09:52:47Z eddieajau $
+* @version		$Id: help.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla.Framework
 * @subpackage	HTML
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/html/toolbar/button/link.php 16/libraries/joomla/html/toolbar/button/link.php
--- 15/libraries/joomla/html/toolbar/button/link.php	2009-05-29 13:54:28.000000000 +0200
+++ 16/libraries/joomla/html/toolbar/button/link.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
-* @version		$Id: link.php 10707 2008-08-21 09:52:47Z eddieajau $
+* @version		$Id: link.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla.Framework
 * @subpackage	HTML
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/html/toolbar/button/popup.php 16/libraries/joomla/html/toolbar/button/popup.php
--- 15/libraries/joomla/html/toolbar/button/popup.php	2009-05-29 13:54:28.000000000 +0200
+++ 16/libraries/joomla/html/toolbar/button/popup.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
-* @version		$Id: popup.php 10707 2008-08-21 09:52:47Z eddieajau $
+* @version		$Id: popup.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla.Framework
 * @subpackage	HTML
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/html/toolbar/button/separator.php 16/libraries/joomla/html/toolbar/button/separator.php
--- 15/libraries/joomla/html/toolbar/button/separator.php	2009-05-29 13:54:28.000000000 +0200
+++ 16/libraries/joomla/html/toolbar/button/separator.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
-* @version		$Id: separator.php 10707 2008-08-21 09:52:47Z eddieajau $
+* @version		$Id: separator.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla.Framework
 * @subpackage	HTML
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/html/toolbar/button/standard.php 16/libraries/joomla/html/toolbar/button/standard.php
--- 15/libraries/joomla/html/toolbar/button/standard.php	2009-05-29 13:54:28.000000000 +0200
+++ 16/libraries/joomla/html/toolbar/button/standard.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
-* @version		$Id: standard.php 10707 2008-08-21 09:52:47Z eddieajau $
+* @version		$Id: standard.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla.Framework
 * @subpackage	HTML
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/html/toolbar/button.php 16/libraries/joomla/html/toolbar/button.php
--- 15/libraries/joomla/html/toolbar/button.php	2009-05-29 13:54:28.000000000 +0200
+++ 16/libraries/joomla/html/toolbar/button.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
-* @version		$Id: button.php 10707 2008-08-21 09:52:47Z eddieajau $
+* @version		$Id: button.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla.Framework
 * @subpackage	HTML
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/html/toolbar.php 16/libraries/joomla/html/toolbar.php
--- 15/libraries/joomla/html/toolbar.php	2009-05-29 13:54:28.000000000 +0200
+++ 16/libraries/joomla/html/toolbar.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
- * @version		$Id: toolbar.php 10707 2008-08-21 09:52:47Z eddieajau $
+ * @version		$Id: toolbar.php 14401 2010-01-26 14:10:00Z louis $
  * @package		Joomla.Framework
  * @subpackage	HTML
- * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+ * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
  * @license		GNU/GPL, see LICENSE.php
  * Joomla! is free software. This version may have been modified pursuant
  * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/import.php 16/libraries/joomla/import.php
--- 15/libraries/joomla/import.php	2009-05-29 13:54:34.000000000 +0200
+++ 16/libraries/joomla/import.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,8 +1,8 @@
 <?php
 /**
-* @version		$Id: import.php 10381 2008-06-01 03:35:53Z pasamio $
+* @version		$Id: import.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/installer/adapters/component.php 16/libraries/joomla/installer/adapters/component.php
--- 15/libraries/joomla/installer/adapters/component.php	2009-05-29 13:54:22.000000000 +0200
+++ 16/libraries/joomla/installer/adapters/component.php	2010-04-23 13:40:18.000000000 +0200
@@ -3,7 +3,7 @@
  * @version		$Id:component.php 6961 2007-03-15 16:06:53Z tcp $
  * @package		Joomla.Framework
  * @subpackage	Installer
- * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+ * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
  * @license		GNU/GPL, see LICENSE.php
  * Joomla! is free software. This version may have been modified pursuant
  * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/installer/adapters/language.php 16/libraries/joomla/installer/adapters/language.php
--- 15/libraries/joomla/installer/adapters/language.php	2009-05-29 13:54:22.000000000 +0200
+++ 16/libraries/joomla/installer/adapters/language.php	2010-04-23 13:40:18.000000000 +0200
@@ -3,7 +3,7 @@
  * @version		$Id:language.php 6961 2007-03-15 16:06:53Z tcp $
  * @package		Joomla.Framework
  * @subpackage	Installer
- * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+ * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
  * @license		GNU/GPL, see LICENSE.php
  * Joomla! is free software. This version may have been modified pursuant
  * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/installer/adapters/module.php 16/libraries/joomla/installer/adapters/module.php
--- 15/libraries/joomla/installer/adapters/module.php	2009-11-04 18:51:20.000000000 +0100
+++ 16/libraries/joomla/installer/adapters/module.php	2010-04-23 13:40:18.000000000 +0200
@@ -3,7 +3,7 @@
  * @version		$Id:module.php 6961 2007-03-15 16:06:53Z tcp $
  * @package		Joomla.Framework
  * @subpackage	Installer
- * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+ * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
  * @license		GNU/GPL, see LICENSE.php
  * Joomla! is free software. This version may have been modified pursuant
  * to the GNU General Public License, and as distributed it includes or
@@ -180,14 +180,19 @@
 			return false;
 		}
 		$id = $db->loadResult();
-
+ 		
+ 		// load module instance
+ 		$row =& JTable::getInstance('module');
+ 		
 		// Was there a module already installed with the same name?
 		// If there was then we wouldn't be here because it would have
 		// been stopped by the above. Otherwise the files weren't there
 		// (e.g. migration) or its an upgrade (files overwritten)
 		// So all we need to do is create an entry when we can't find one
-		if (!$id) {
-			$row = & JTable::getInstance('module');
+
+		if ($id) {
+			$row->load($id);
+		} else {
 			$row->title = JText::_($this->get('name'));
 			$row->ordering = $row->getNextOrder( "position='left'" );
 			$row->position = 'left';
diff -aruN --binary 15/libraries/joomla/installer/adapters/plugin.php 16/libraries/joomla/installer/adapters/plugin.php
--- 15/libraries/joomla/installer/adapters/plugin.php	2009-11-04 18:51:20.000000000 +0100
+++ 16/libraries/joomla/installer/adapters/plugin.php	2010-04-23 13:40:18.000000000 +0200
@@ -3,7 +3,7 @@
  * @version		$Id:plugin.php 6961 2007-03-15 16:06:53Z tcp $
  * @package		Joomla.Framework
  * @subpackage	Installer
- * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+ * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
  * @license		GNU/GPL, see LICENSE.php
  * Joomla! is free software. This version may have been modified pursuant
  * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/installer/adapters/template.php 16/libraries/joomla/installer/adapters/template.php
--- 15/libraries/joomla/installer/adapters/template.php	2009-05-29 13:54:22.000000000 +0200
+++ 16/libraries/joomla/installer/adapters/template.php	2010-04-23 13:40:18.000000000 +0200
@@ -3,7 +3,7 @@
 * @version		$Id:template.php 6961 2007-03-15 16:06:53Z tcp $
 * @package		Joomla.Framework
 * @subpackage	Installer
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/installer/helper.php 16/libraries/joomla/installer/helper.php
--- 15/libraries/joomla/installer/helper.php	2009-05-29 13:54:22.000000000 +0200
+++ 16/libraries/joomla/installer/helper.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
- * @version		$Id: helper.php 11299 2008-11-22 01:40:44Z ian $
+ * @version		$Id: helper.php 14401 2010-01-26 14:10:00Z louis $
  * @package		Joomla.Framework
  * @subpackage	Installer
- * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+ * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
  * @license		GNU/GPL, see LICENSE.php
  * Joomla! is free software. This version may have been modified pursuant
  * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/installer/installer.php 16/libraries/joomla/installer/installer.php
--- 15/libraries/joomla/installer/installer.php	2009-05-29 13:54:22.000000000 +0200
+++ 16/libraries/joomla/installer/installer.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
- * @version		$Id: installer.php 11646 2009-03-01 19:34:56Z ian $
+ * @version		$Id: installer.php 14401 2010-01-26 14:10:00Z louis $
  * @package		Joomla.Framework
  * @subpackage	Installer
- * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+ * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
  * @license		GNU/GPL, see LICENSE.php
  * Joomla! is free software. This version may have been modified pursuant
  * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/language/helper.php 16/libraries/joomla/language/helper.php
--- 15/libraries/joomla/language/helper.php	2009-05-29 13:54:20.000000000 +0200
+++ 16/libraries/joomla/language/helper.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
-* @version		$Id: helper.php 10386 2008-06-01 21:37:15Z pasamio $
+* @version		$Id: helper.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla.Framework
 * @subpackage	Language
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/language/help.php 16/libraries/joomla/language/help.php
--- 15/libraries/joomla/language/help.php	2009-11-04 18:51:20.000000000 +0100
+++ 16/libraries/joomla/language/help.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
-* @version		$Id: help.php 13341 2009-10-27 03:03:54Z ian $
+* @version		$Id: help.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla.Framework
 * @subpackage	Language
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/language/language.php 16/libraries/joomla/language/language.php
--- 15/libraries/joomla/language/language.php	2009-11-04 18:51:20.000000000 +0100
+++ 16/libraries/joomla/language/language.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
-* @version		$Id: language.php 13297 2009-10-24 01:29:37Z ian $
+* @version		$Id: language.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla.Framework
 * @subpackage	Language
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/mail/helper.php 16/libraries/joomla/mail/helper.php
--- 15/libraries/joomla/mail/helper.php	2009-05-29 13:54:20.000000000 +0200
+++ 16/libraries/joomla/mail/helper.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
- * @version		$Id: helper.php 11380 2009-01-01 15:48:59Z ian $
+ * @version		$Id: helper.php 14401 2010-01-26 14:10:00Z louis $
  * @package		Joomla.Framework
  * @subpackage	Mail
- * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+ * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
  * @license		GNU/GPL, see LICENSE.php
  * Joomla! is free software. This version may have been modified pursuant
  * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/mail/mail.php 16/libraries/joomla/mail/mail.php
--- 15/libraries/joomla/mail/mail.php	2009-06-30 21:01:32.000000000 +0200
+++ 16/libraries/joomla/mail/mail.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
- * @version		$Id: mail.php 12308 2009-06-23 04:05:28Z ian $
+ * @version		$Id: mail.php 14401 2010-01-26 14:10:00Z louis $
  * @package		Joomla.Framework
  * @subpackage	Mail
- * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+ * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
  * @license		GNU/GPL, see LICENSE.php
  * Joomla! is free software. This version may have been modified pursuant
  * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/methods.php 16/libraries/joomla/methods.php
--- 15/libraries/joomla/methods.php	2009-05-29 13:54:34.000000000 +0200
+++ 16/libraries/joomla/methods.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,8 +1,8 @@
 <?php
 /**
-* @version		$Id: methods.php 11646 2009-03-01 19:34:56Z ian $
+* @version		$Id: methods.php 14401 2010-01-26 14:10:00Z louis $
 * @package		Joomla.Framework
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
diff -aruN --binary 15/libraries/joomla/plugin/helper.php 16/libraries/joomla/plugin/helper.php
--- 15/libraries/joomla/plugin/helper.php	2009-05-29 13:54:22.000000000 +0200
+++ 16/libraries/joomla/plugin/helper.php	2010-04-23 13:40:18.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
-* @version		$Id: helper.php 10707 2008-08-21 09:52:47Z eddieajau $
+* @version		$Id: helper.php 16381 2010-04-23 09:28:44Z ian $
 * @package		Joomla.Framework
 * @subpackage	Plugin
-* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
@@ -111,10 +111,19 @@
 	function _import( &$plugin, $autocreate = true, $dispatcher = null )
 	{
 		static $paths;
+		static $shutdown_handler_installed;
+		$mainframe =& JFactory::getApplication();
 
 		if (!$paths) {
 			$paths = array();
 		}
+	
+		// Install shutdown handler if not installed yet
+		if(!$shutdown_handler_installed)
+		{
+			register_shutdown_function(array('JPluginHelper', 'shutdown'));
+			$shutdown_handler_installed = true;
+		}
 
 		$result	= false;
 		$plugin->type = preg_replace('/[^A-Z0-9_\.-]/i', '', $plugin->type);
@@ -130,6 +139,7 @@
 				global $_MAMBOTS, $mainframe;
 
 				jimport('joomla.plugin.plugin');
+				$mainframe->set('currentPlugin', $plugin);
 				require_once( $path );
 				$paths[$path] = true;
 
@@ -148,12 +158,10 @@
 
 						// create the plugin
 						$instance = new $className($dispatcher, (array)($plugin));
+						
 					}
 				}
-			}
-			else
-			{
-				$paths[$path] = false;
+				$mainframe->set('currentPlugin', NULL);
 			}
 		}
 	}
@@ -202,4 +210,86 @@
 		return $plugins;
 	}
 
+	/**
+	 * Shutdown handler called by PHP when executing plugin produces a fatal error
+	 *
+	 * @access public
+	 */
+	static function shutdown()
+	{
+		global $mainframe;
+		$currentPlugin = $mainframe->get('currentPlugin', NULL);
+
+		if($currentPlugin)
+		{
+			$error = error_get_last();
+			if($error['type'] == E_ERROR || $error['type'] == E_PARSE || $error['type'] == E_COMPILE_ERROR)
+			{
+
+				$disabled = false;
+				$cfg =& JFactory::getConfig();
+
+				/* If not in debug mode, attempt to disable the plugin */
+				if(!$cfg->getValue('config.debug'))
+				{
+					$db =& JFactory::getDBO();
+					$q = 'UPDATE #__plugins SET `published`=0 WHERE `folder`=' . $db->quote($currentPlugin->type) . 
+						 'AND `element`=' . $db->quote($currentPlugin->name) .
+						 'LIMIT 1';
+					$db->setQuery($q);
+					$disabled = $db->query();
+
+					/* Following code is based on com_weblinks */
+
+					// admin users gid
+					$gid = 25;
+
+					// list of admins
+					$query = 'SELECT email, name' .
+							' FROM #__users' .
+							' WHERE gid = ' . $gid .
+							' AND sendEmail = 1';
+					$db->setQuery($query);
+					if ($db->query()) 
+					{
+						$adminRows = $db->loadObjectList();
+						$mail =& JFactory::getMailer();
+
+						// send email notification to admins
+						foreach ($adminRows as $adminRow) 
+						{
+							$mail->addRecipient($adminRow->email, $adminRow->name);
+						}
+
+						$uri = JURI::getInstance();
+						$mail->setSubject(JText::sprintf('Problem with Joomla site at %s'), $uri->getHost());
+
+						$body = JText::sprintf('When trying to access %s, and error was detected with %s plugin %s and it has been disabled. Technical error description follows:', JURI::current(), $currentPlugin->type, $currentPlugin->name);
+						$body .= "\n";
+						$body .= "\n" . $error['message'];
+						$body .= "\n" . $error['file'] . ' : ' . $error['line'];
+						$mail->setBody($body);
+
+						$mail->send();
+					}
+				}
+
+				if($disabled)
+				{
+					$app = JFactory::getApplication();
+					$app->redirect(JURI::current());
+				}
+				else
+				{
+					JError::raise(
+							$error['type'], 
+							500, 
+							JText::sprintf('Error loading %s plugin "%s"', $currentPlugin->type, $currentPlugin->name),
+							JText::sprintf('%s : %d', $error['file'], $error['line']), 
+							$currentPlugin
+							);
+				}
+			}
+		}
+	}
 }
diff -aruN --binary 15/libraries/joomla/plugin/helper-php4.php 16/libraries/joomla/plugin/helper-php4.php
--- 15/libraries/joomla/plugin/helper-php4.php	1970-01-01 01:00:00.000000000 +0100
+++ 16/libraries/joomla/plugin/helper-php4.php	2010-04-25 00:54:26.000000000 +0200
@@ -0,0 +1,205 @@
+<?php
+/**
+* @version		$Id: helper.php 10707 2008-08-21 09:52:47Z eddieajau $
+* @package		Joomla.Framework
+* @subpackage	Plugin
+* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
+* @license		GNU/GPL, see LICENSE.php
+* Joomla! is free software. This version may have been modified pursuant
+* to the GNU General Public License, and as distributed it includes or
+* is derivative of works licensed under the GNU General Public License or
+* other free or open source software licenses.
+* See COPYRIGHT.php for copyright notices and details.
+*/
+
+// Check to ensure this file is within the rest of the framework
+defined('JPATH_BASE') or die();
+
+/**
+* Plugin helper class
+*
+* @static
+* @package		Joomla.Framework
+* @subpackage	Plugin
+* @since		1.5
+*/
+class JPluginHelper
+{
+	/**
+	 * Get the plugin data of a specific type if no specific plugin is specified
+	 * otherwise only the specific plugin data is returned
+	 *
+	 * @access public
+	 * @param string 	$type 	The plugin type, relates to the sub-directory in the plugins directory
+	 * @param string 	$plugin	The plugin name
+	 * @return mixed 	An array of plugin data objects, or a plugin data object
+	 */
+	function &getPlugin($type, $plugin = null)
+	{
+		$result = array();
+
+		$plugins = JPluginHelper::_load();
+
+		$total = count($plugins);
+		for($i = 0; $i < $total; $i++)
+		{
+			if(is_null($plugin))
+			{
+				if($plugins[$i]->type == $type) {
+					$result[] = $plugins[$i];
+				}
+			}
+			else
+			{
+				if($plugins[$i]->type == $type && $plugins[$i]->name == $plugin) {
+					$result = $plugins[$i];
+					break;
+				}
+			}
+
+		}
+
+		return $result;
+	}
+
+	/**
+	 * Checks if a plugin is enabled
+	 *
+	 * @access	public
+	 * @param string 	$type 	The plugin type, relates to the sub-directory in the plugins directory
+	 * @param string 	$plugin	The plugin name
+	 * @return	boolean
+	 */
+	function isEnabled( $type, $plugin = null )
+	{
+		$result = &JPluginHelper::getPlugin( $type, $plugin);
+		return (!empty($result));
+	}
+
+	/**
+	* Loads all the plugin files for a particular type if no specific plugin is specified
+	* otherwise only the specific pugin is loaded.
+	*
+	* @access public
+	* @param string 	$type 	The plugin type, relates to the sub-directory in the plugins directory
+	* @param string 	$plugin	The plugin name
+	* @return boolean True if success
+	*/
+	function importPlugin($type, $plugin = null, $autocreate = true, $dispatcher = null)
+	{
+		$result = false;
+
+		$plugins = JPluginHelper::_load();
+
+		$total = count($plugins);
+		for($i = 0; $i < $total; $i++) {
+			if($plugins[$i]->type == $type && ($plugins[$i]->name == $plugin ||  $plugin === null)) {
+				JPluginHelper::_import( $plugins[$i], $autocreate, $dispatcher );
+				$result = true;
+			}
+		}
+
+		return $result;
+	}
+
+	/**
+	 * Loads the plugin file
+	 *
+	 * @access private
+	 * @return boolean True if success
+	 */
+	function _import( &$plugin, $autocreate = true, $dispatcher = null )
+	{
+		static $paths;
+
+		if (!$paths) {
+			$paths = array();
+		}
+
+		$result	= false;
+		$plugin->type = preg_replace('/[^A-Z0-9_\.-]/i', '', $plugin->type);
+		$plugin->name  = preg_replace('/[^A-Z0-9_\.-]/i', '', $plugin->name);
+
+		$path	= JPATH_PLUGINS.DS.$plugin->type.DS.$plugin->name.'.php';
+
+		if (!isset( $paths[$path] ))
+		{
+			if (file_exists( $path ))
+			{
+				//needed for backwards compatibility
+				global $_MAMBOTS, $mainframe;
+
+				jimport('joomla.plugin.plugin');
+				require_once( $path );
+				$paths[$path] = true;
+
+				if($autocreate)
+				{
+					// Makes sure we have an event dispatcher
+					if(!is_object($dispatcher)) {
+						$dispatcher = & JDispatcher::getInstance();
+					}
+
+					$className = 'plg'.$plugin->type.$plugin->name;
+					if(class_exists($className))
+					{
+						// load plugin parameters
+						$plugin =& JPluginHelper::getPlugin($plugin->type, $plugin->name);
+
+						// create the plugin
+						$instance = new $className($dispatcher, (array)($plugin));
+					}
+				}
+			}
+			else
+			{
+				$paths[$path] = false;
+			}
+		}
+	}
+
+	/**
+	 * Loads the published plugins
+	 *
+	 * @access private
+	 */
+	function _load()
+	{
+		static $plugins;
+
+		if (isset($plugins)) {
+			return $plugins;
+		}
+
+		$db		=& JFactory::getDBO();
+		$user	=& JFactory::getUser();
+
+		if (isset($user))
+		{
+			$aid = $user->get('aid', 0);
+
+			$query = 'SELECT folder AS type, element AS name, params'
+				. ' FROM #__plugins'
+				. ' WHERE published >= 1'
+				. ' AND access <= ' . (int) $aid
+				. ' ORDER BY ordering';
+		}
+		else
+		{
+			$query = 'SELECT folder AS type, element AS name, params'
+				. ' FROM #__plugins'
+				. ' WHERE published >= 1'
+				. ' ORDER BY ordering';
+		}
+
+		$db->setQuery( $query );
+
+		if (!($plugins = $db->loadObjectList())) {
+			JError::raiseWarning( 'SOME_ERROR_CODE', "Error loading Plugins: " . $db->getErrorMsg());
+			return false;
+		}
+
+		return $plugins;
+	}
+
+}
